def benjamini_hochberg(p_values):
    # Attach original ordering to p_value list
    p = list(enumerate(p_values))
    # Sort in ascending order of p_values
    p.sort(key=lambda pair: pair[1])
    # Compute FDRs from largest p_values first
    fdrs = [0] * len(p_values)
    n = float(len(p))
    min_fdr = 1
    for rank, (i, p_value) in reversed(list(enumerate(p))):
        fdr = min(min_fdr, n / (rank + 1) * p_value)
        min_fdr = min(min_fdr, fdr)
        fdrs[i] = fdr
    return fdrs
